#ifndef _MDTMAINLOOP_H
#define _MDTMAINLOOP_H
/* -*- mode: C; -*- */

/*
   Copyright (c) 1997-2002 MathEngine PLC

   $Name:  $

   Date: $Date: 2003/05/05 00:57:07 $ - Revision: $Revision: 1.1 $

   This software and its accompanying manuals have been developed
   by MathEngine PLC ("MathEngine") and the copyright and all other
   intellectual property rights in them belong to MathEngine. All
   rights conferred by law (including rights under international
   copyright conventions) are reserved to MathEngine. This software
   may also incorporate information which is confidential to
   MathEngine.

   Save to the extent permitted by law, or as otherwise expressly
   permitted by MathEngine, this software and the manuals must not
   be copied (in whole or in part), re-arranged, altered or adapted
   in any way without the prior written consent of the Company. In
   addition, the information contained in the software may not be
   disseminated without the prior written consent of MathEngine.

 */

#include <MdtTypes.h>

#ifdef __cplusplus
extern "C"
{
#endif

MEPUBLIC
void            MEAPI MdtAutoDisableLastPartition(MdtPartitionOutput* po,
                        void* cbdata);

MEPUBLIC
unsigned int    MEAPI MdtPackAllPartitions(const MdtPartitionOutput* po,
                        const MeReal stepSize, MdtWorldParams* params,
                        MdtSolverParameters* keaParams,
                        MdtKeaTransformation* keaTMArray,
                        MdtConstraints* constraints,
						MdtSolverType solverType);

MEPUBLIC
unsigned int    MEAPI MdtPackPartition(const MdtPartitionOutput* po,
                        const unsigned int partitionindex,
                        const MeReal stepSize, MdtWorldParams* params,
                        MdtSolverParameters* keaParams,
                        MdtKeaTransformation* keaTMArray,
                        MdtConstraints* constraints,
						MdtSolverType solverType);

MEPUBLIC
void            MEAPI MdtAllocateArthurMemory(MdtArthurInterData *    interData,      /* Output */
                        void **                 interDataPool,  /* Input */
                        MeChunk *               interDataChunk, /* Input */
                        const int               Jsize[],        /* Input */
                        int                     numConstraints, /* Input */
                        int                     numBodies,      /* Input */
                        int                     numPartitions); /* Input */

MEPUBLIC
void            MEAPI MdtAllocateSolverMemory(MdtSolverOutputData *   outputData,     
                       MdtSolverInputData *    inputData,      
					   void **                 solverDataPool,  
					   MeChunk *               solverDataChunk,          
                       const int               Jsize[],        
					   int                     numConstraints, 
                       int                     numBodies,      
                       int                     numPartitions); 

MEPUBLIC
void            MEAPI MdtUnpackBodies(MdtKeaTransformation* keaTMArray,
                        const unsigned int partitionindex, 
			            MdtPartitionOutput* po);

MEPUBLIC
unsigned int    MEAPI MdtUnpackForces(const unsigned int partitionindex, 
                        MdtPartitionOutput* po,
                        MdtVelocityJacobian J,
                        MeI32Array numRowsConstraint,
                        MeReal lambda[],
                        MeBool calcIndividualContactForces);

MEPUBLIC
void            MEAPI MdtMakeBodyForcesPointerArray(MeLinAngPtrArray *        externalForce,  /* Output */
                        MeLinAngPtrArray *        resultantForce, /* Output */
                        MdtKeaBody *const         blist[],        /* Input */ 
                        int                       numBodies);     /* Input */

MEPUBLIC
void            MEAPI MdtMakeConstraintForcesPointerArray(MeLinAngPairPtrArray *     constraintForce,
                        MdtBaseConstraint *        constraintArray[],
                        const int                  constraintsStart[],
                        const int                  constraintsSize[],
                        int                        nPartitions);

MEPUBLIC
MeReal          MEAPI MdtPartitionGetSafeTime(MdtPartitionOutput* po, int i);



void            MEAPI MdtLODLastPartition(MdtPartitionOutput* po, 
                                    MdtPartitionParams* params);

MEPUBLIC
MdtConstraints*  MEAPI MdtConstraintsCreateFromChunk(MeChunk* chunk,
                            int maxPartitions,
                            int maxKeaConstraints,
                            int maxRows);

MEPUBLIC
void            MEAPI MdtDefaultSimErrorCallBack(MeLinAngPairPtrArray constraintForce, 
                                                 MdtKeaBody** kb, 
                                                 int nBodies, 
                                                 void* secbdata);


#ifdef __cplusplus
}
#endif

#endif
